Index: .gitignore
===================================================================
--- .gitignore	(revision a93d6b18321029c0ea7ea1247c872fba3d75f8e0)
+++ .gitignore	(revision bc87305316c560a93eeaf77db05eb6721733d636)
@@ -15,4 +15,6 @@
 .mplconfig
 
+/setup.cfg
+
 /dist
 /build
@@ -21,4 +23,5 @@
 **/test/logs
 *.pyc
+*.so
 default_categories.json
 
@@ -34,2 +37,6 @@
 /docs/sphinx-docs/source/user/perspectives
 
+# test outputs
+/test/pr_inversion/test/test_output.txt
+/test/sasdataloader/test/plugins.zip
+/test/sasdataloader/test/test_log.txt
Index: sasview/sasview.py
===================================================================
--- sasview/sasview.py	(revision 199bb42b1d8cc0dd3885c291e634d038962b5550)
+++ sasview/sasview.py	(revision 85130cb3582eef4c433e40ac08435fe6040abbf1)
@@ -69,8 +69,13 @@
 
 import wx
+
 try:
     logging.info("Wx version: %s" % wx.__version__)
 except:
     logging.error("Wx version: error reading version")
+
+import wxcruft
+wxcruft.call_later_fix()
+#wxcruft.trace_new_id()
 
 # The below will make sure that sasview application uses the matplotlib font
Index: sasview/wxcruft.py
===================================================================
--- sasview/wxcruft.py	(revision 6f16e25ca8391464dfcea6ba0d48d6b3702d148e)
+++ sasview/wxcruft.py	(revision 6f16e25ca8391464dfcea6ba0d48d6b3702d148e)
@@ -0,0 +1,165 @@
+import inspect
+import wx
+from wx import Timer
+import wx._misc
+
+def call_later_fix():
+    # TODO: test if we need the fix
+    wx.CallLater = CallLater
+    wx.FutureCall = FutureCall
+    wx.PyTimer = PyTimer
+
+def trace_new_id():
+    wx.NewId = NewId
+
+def NewId():
+    id = wx._misc.NewId()
+    path, line, function = _get_caller()
+    if path == "sas/guiframe/utils.py":
+        # Special case: NewId is being called via an IdList request; we
+        # want to which widget triggered the request, not that it was
+        # triggered via IdList.
+        path, line, function = _get_caller(2)
+        tag = " via IdList"
+    elif path.endswith("/wxcruft.py"):
+        # Special case: NewId is being called via CallLater; we want to
+        # know where the CallLater was invoked.
+        path, line, function = _get_caller(1)
+        tag = " via CallLater"
+    else:
+        tag = ""
+    print "NewId %d from %s(%d):%s%s"%(id, path, line, function, tag)
+    return id
+
+def _get_caller(distance=0):
+    frame = inspect.stack()[distance+2]
+    path = frame[1]
+    index = path.find('/sas/')
+    if index == -1: index = path.find('\\sas\\')
+    return path[index+1:], frame[2], frame[3]
+
+
+
+# ==========================================================================
+# Hacked versions of CallLater and PyTimer so that the main GUI loop doesn't
+# eat wx ids.
+# Changed lines are marked #PAK
+# ==========================================================================
+
+# For backwards compatibility with 2.4
+class PyTimer(Timer):
+    def __init__(self, notify, *args, **kw):  #PAK
+        Timer.__init__(self, *args, **kw)     #PAK
+        self.notify = notify
+
+    def Notify(self):
+        if self.notify:
+            self.notify()
+
+
+class CallLater:
+    """
+    A convenience class for `wx.Timer`, that calls the given callable
+    object once after the given amount of milliseconds, passing any
+    positional or keyword args.  The return value of the callable is
+    availbale after it has been run with the `GetResult` method.
+
+    If you don't need to get the return value or restart the timer
+    then there is no need to hold a reference to this object.
+
+    :see: `wx.CallAfter`
+    """
+
+    __RUNNING = set()
+
+    def __init__(self, millis, callableObj, *args, **kwargs):
+        # print "=================== entering CallLater constructor"
+        assert callable(callableObj), "callableObj is not callable"
+        self.millis = millis
+        self.callable = callableObj
+        self.SetArgs(*args, **kwargs)
+        self.runCount = 0
+        self.running = False
+        self.hasRun = False
+        self.result = None
+        self.timer = None
+        self.id = wx.NewId()  # PAK
+        self.Start()
+
+
+    def Start(self, millis=None, *args, **kwargs):
+        """
+        (Re)start the timer
+        """
+        self.hasRun = False
+        if millis is not None:
+            self.millis = millis
+        if args or kwargs:
+            self.SetArgs(*args, **kwargs)
+        self.Stop()
+        self.timer = PyTimer(self.Notify, id=self.id)  # PAK
+        self.timer.Start(self.millis, wx.TIMER_ONE_SHOT)
+        self.running = True
+        self.__RUNNING.add(self)
+    Restart = Start
+
+
+    def Stop(self):
+        """
+        Stop and destroy the timer.
+        """
+        if self.timer is not None:
+            self.timer.Stop()
+            self.timer = None
+        self.__RUNNING.discard(self)
+
+
+    def GetInterval(self):
+        if self.timer is not None:
+            return self.timer.GetInterval()
+        else:
+            return 0
+
+
+    def IsRunning(self):
+        return self.timer is not None and self.timer.IsRunning()
+
+
+    def SetArgs(self, *args, **kwargs):
+        """
+        (Re)set the args passed to the callable object.  This is
+        useful in conjunction with Restart if you want to schedule a
+        new call to the same callable object but with different
+        parameters.
+        """
+        self.args = args
+        self.kwargs = kwargs
+
+
+    def HasRun(self):
+        return self.hasRun
+
+
+    def GetResult(self):
+        return self.result
+
+
+    def Notify(self):
+        """
+        The timer has expired so call the callable.
+        """
+        if self.callable and getattr(self.callable, 'im_self', True):
+            self.runCount += 1
+            self.running = False
+            self.result = self.callable(*self.args, **self.kwargs)
+        self.hasRun = True
+        if not self.running:
+            # if it wasn't restarted, then cleanup
+            wx.CallAfter(self.Stop)
+
+    Interval = property(GetInterval)
+    Result = property(GetResult)
+
+
+class FutureCall(CallLater):
+    """A compatibility alias for `CallLater`."""
Index: src/sas/guiframe/gui_toolbar.py
===================================================================
--- src/sas/guiframe/gui_toolbar.py	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ src/sas/guiframe/gui_toolbar.py	(revision 6f16e25ca8391464dfcea6ba0d48d6b3702d148e)
@@ -36,4 +36,5 @@
     Implement toolbar for guiframe
     """
+    ID_BOOKMARK = wx.NewId()
     def __init__(self, parent,  *args, **kwds):
         Tbar.__init__(self, parent,  *args, **kwds)
@@ -133,8 +134,7 @@
         Add default items in bookmark menu
         """
-        id = wx.NewId()
-        self._bookmark_menu.Append(id, 'Bookmark This Page State')
+        self._bookmark_menu.Append(self.ID_BOOKMARK, 'Bookmark This Page State')
         self._bookmark_menu.AppendSeparator()
-        wx.EVT_MENU(self, id, self.on_bookmark)
+        wx.EVT_MENU(self, self.ID_BOOKMARK, self.on_bookmark)
    
     def on_bind_button(self):
Index: src/sas/guiframe/local_perspectives/plotting/Plotter1D.py
===================================================================
--- src/sas/guiframe/local_perspectives/plotting/Plotter1D.py	(revision 098f3d277d54e6ae4bae35ed0188be84b67fb171)
+++ src/sas/guiframe/local_perspectives/plotting/Plotter1D.py	(revision 6f16e25ca8391464dfcea6ba0d48d6b3702d148e)
@@ -19,5 +19,5 @@
 from sas.guiframe.events import StatusEvent
 from sas.guiframe.events import PanelOnFocusEvent
-from sas.guiframe.utils import PanelMenu
+from sas.guiframe.utils import PanelMenu, IdList
 from sas.guiframe.panel_base import PanelBase
 from sas.guiframe.gui_style import GUIFRAME_ICON
@@ -35,6 +35,4 @@
     """return the key of dictionary dic given the value"""
     return [k for k, v in dic.iteritems() if v == val][0]
-
-
 
 class ModelPanel1D(PlotPanel, PanelBase):
@@ -52,4 +50,5 @@
     ## Group ID
     group_id = None
+    _menu_ids = IdList()
 
     def __init__(self, parent, id=-1, color=None,
@@ -68,5 +67,4 @@
 
         self._available_data = []
-        self._menu_add_ids = []
         self._symbol_labels = self.get_symbol_label()
         self._color_labels = self.get_color_label()
@@ -556,14 +554,15 @@
         self._slicerpop.set_plots(self.plots)
         self._slicerpop.set_graph(self.graph)
+        ids = iter(self._menu_ids)
         if not self.graph.selected_plottable in self.plots:
             # Various plot options
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             self._slicerpop.Append(wx_id, '&Save Image', 'Save image as PNG')
             wx.EVT_MENU(self, wx_id, self.onSaveImage)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             self._slicerpop.Append(wx_id, '&Print Image', 'Print image ')
             wx.EVT_MENU(self, wx_id, self.onPrint)
 
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             self._slicerpop.Append(wx_id, '&Copy to Clipboard',
                                    'Copy to the clipboard')
@@ -582,8 +581,8 @@
                     continue
 
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             plot_menu.Append(wx_id, "&DataInfo", name)
             wx.EVT_MENU(self, wx_id, self. _onDataShow)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             plot_menu.Append(wx_id, "&Save Points as a File", name)
             wx.EVT_MENU(self, wx_id, self._onSave)
@@ -592,10 +591,13 @@
             # add menu of other plugins
             item_list = self.parent.get_current_context_menu(self)
-
             if (not item_list == None) and (not len(item_list) == 0):
-                for item in item_list:
+                # Note: reusing menu ids in submenu.  This code works because
+                # IdItems is set up as a lazy iterator returning each id in
+                # sequence, creating new ids as needed so it never runs out.
+                # zip() is set up to stop when any iterator is empty, so it
+                # only asks for the number of ids in item_list.
+                for item, wx_id in zip(item_list, self._menu_ids):
 
                     try:
-                        wx_id = wx.NewId()
                         plot_menu.Append(wx_id, item[0], name)
                         wx.EVT_MENU(self, wx_id, item[2])
@@ -607,14 +609,14 @@
 
             if self.parent.ClassName.count('wxDialog') == 0:
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 plot_menu.Append(wx_id, '&Linear Fit', name)
                 wx.EVT_MENU(self, wx_id, self.onFitting)
                 plot_menu.AppendSeparator()
 
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 plot_menu.Append(wx_id, "Remove", name)
                 wx.EVT_MENU(self, wx_id, self._onRemove)
                 if not plot.is_data:
-                    wx_id = wx.NewId()
+                    wx_id = ids.next()
                     plot_menu.Append(wx_id, '&Freeze', name)
                     wx.EVT_MENU(self, wx_id, self.onFreeze)
@@ -622,5 +624,5 @@
 
                 if plot.is_data:
-                    wx_id = wx.NewId()
+                    wx_id = ids.next()
                     self.hide_menu = plot_menu.Append(wx_id, "Hide Error Bar", name)
 
@@ -636,8 +638,8 @@
                     plot_menu.AppendSeparator()
 
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 plot_menu.Append(wx_id, '&Modify Plot Property', name)
                 wx.EVT_MENU(self, wx_id, self.createAppDialog)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             # plot_menu.SetTitle(name)
             self._slicerpop.AppendMenu(wx_id, '&%s' % name, plot_menu)
@@ -648,9 +650,9 @@
             loc_menu = wx.Menu()
             for label in self._loc_labels:
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 loc_menu.Append(wx_id, str(label), str(label))
                 wx.EVT_MENU(self, wx_id, self.onChangeLegendLoc)
 
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             self._slicerpop.Append(wx_id, '&Modify Graph Appearance',
                                    'Modify graph appearance')
@@ -660,16 +662,16 @@
 
             if self.position != None:
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 self._slicerpop.Append(wx_id, '&Add Text')
                 wx.EVT_MENU(self, wx_id, self._on_addtext)
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 self._slicerpop.Append(wx_id, '&Remove Text')
                 wx.EVT_MENU(self, wx_id, self._on_removetext)
                 self._slicerpop.AppendSeparator()
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             self._slicerpop.Append(wx_id, '&Change Scale')
             wx.EVT_MENU(self, wx_id, self._onProperties)
             self._slicerpop.AppendSeparator()
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             self._slicerpop.Append(wx_id, '&Reset Graph Range')
             wx.EVT_MENU(self, wx_id, self.onResetGraph)
@@ -677,5 +679,5 @@
             if self.parent.ClassName.count('wxDialog') == 0:
                 self._slicerpop.AppendSeparator()
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 self._slicerpop.Append(wx_id, '&Window Title')
                 wx.EVT_MENU(self, wx_id, self.onChangeCaption)
Index: src/sas/guiframe/local_perspectives/plotting/Plotter2D.py
===================================================================
--- src/sas/guiframe/local_perspectives/plotting/Plotter2D.py	(revision 098f3d277d54e6ae4bae35ed0188be84b67fb171)
+++ src/sas/guiframe/local_perspectives/plotting/Plotter2D.py	(revision 6f16e25ca8391464dfcea6ba0d48d6b3702d148e)
@@ -287,17 +287,18 @@
 
         """
+        ids = iter(self._menu_ids)
         slicerpop = PanelMenu()
         slicerpop.set_plots(self.plots)
         slicerpop.set_graph(self.graph)
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&Save Image')
         wx.EVT_MENU(self, wx_id, self.onSaveImage)
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&Print Image', 'Print image')
         wx.EVT_MENU(self, wx_id, self.onPrint)
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&Copy to Clipboard', 'Copy to the clipboard')
         wx.EVT_MENU(self, wx_id, self.OnCopyFigureMenu)
@@ -305,9 +306,9 @@
         # saving data
         plot = self.data2D
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, "&Data Info")
         wx.EVT_MENU(self, wx_id, self._onDataShow)
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, "&Save as a File (DAT)")
         self.action_ids[str(wx_id)] = plot
@@ -320,7 +321,7 @@
                 self.data2D.name.split(" ")[0] != 'Residuals':
                 # The line above; Not for trunk
-                for item in item_list:
+                # Note: reusing menu ids for the sub-menus.  See Plotter1D.
+                for item, wx_id in zip(item_list, self._menu_ids):
                     try:
-                        wx_id = wx.NewId()
                         slicerpop.Append(wx_id, item[0], item[1])
                         wx.EVT_MENU(self, wx_id, item[2])
@@ -331,38 +332,38 @@
                 slicerpop.AppendSeparator()
 
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             slicerpop.Append(wx_id, '&Perform Circular Average')
             wx.EVT_MENU(self, wx_id, self.onCircular) \
             # For Masked Data
             if not plot.mask.all():
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 slicerpop.Append(wx_id, '&Masked Circular Average')
                 wx.EVT_MENU(self, wx_id, self.onMaskedCircular)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             slicerpop.Append(wx_id, '&Sector [Q View]')
             wx.EVT_MENU(self, wx_id, self.onSectorQ)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             slicerpop.Append(wx_id, '&Annulus [Phi View ]')
             wx.EVT_MENU(self, wx_id, self.onSectorPhi)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             slicerpop.Append(wx_id, '&Box Sum')
             wx.EVT_MENU(self, wx_id, self.onBoxSum)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             slicerpop.Append(wx_id, '&Box Averaging in Qx')
             wx.EVT_MENU(self, wx_id, self.onBoxavgX)
-            wx_id = wx.NewId()
+            wx_id = ids.next()
             slicerpop.Append(wx_id, '&Box Averaging in Qy')
             wx.EVT_MENU(self, wx_id, self.onBoxavgY)
             if self.slicer != None:
-                wx_id = wx.NewId()
+                wx_id = ids.next()
                 slicerpop.Append(wx_id, '&Clear Slicer')
                 wx.EVT_MENU(self, wx_id, self.onClearSlicer)
                 if self.slicer.__class__.__name__ != "BoxSum":
-                    wx_id = wx.NewId()
+                    wx_id = ids.next()
                     slicerpop.Append(wx_id, '&Edit Slicer Parameters')
                     wx.EVT_MENU(self, wx_id, self._onEditSlicer)
             slicerpop.AppendSeparator()
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&Edit Graph Label', 'Edit Graph Label')
         wx.EVT_MENU(self, wx_id, self.onEditLabels)
@@ -371,20 +372,20 @@
         # ILL mod here
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&Modify graph appearance', 'Modify graph appearance')
         wx.EVT_MENU(self, wx_id, self.modifyGraphAppearance)
         slicerpop.AppendSeparator()
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&2D Color Map')
         wx.EVT_MENU(self, wx_id, self._onEditDetector)
         slicerpop.AppendSeparator()
 
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&Toggle Linear/Log Scale')
         wx.EVT_MENU(self, wx_id, self._onToggleScale)
 
         slicerpop.AppendSeparator()
-        wx_id = wx.NewId()
+        wx_id = ids.next()
         slicerpop.Append(wx_id, '&Window Title')
         wx.EVT_MENU(self, wx_id, self.onChangeCaption)
Index: src/sas/guiframe/utils.py
===================================================================
--- src/sas/guiframe/utils.py	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ src/sas/guiframe/utils.py	(revision 6f16e25ca8391464dfcea6ba0d48d6b3702d148e)
@@ -123,2 +123,75 @@
     return begin_flag, end_flag
 
+class IdList:
+    """
+    Create a list of wx ids that can be reused.
+
+    Ids for items need to be unique within their context.  In a dynamic
+    application where the number of ids needed different each time the
+    form is created, depending for example, on the number of items that
+    need to be shown in the context menu, you cannot preallocate the
+    ids that you are going to use for the form.  Instead, you can use
+    an IdList, which will reuse ids from context to context, adding new
+    ones if the new context requires more than a previous context.
+
+    IdList is set up as an iterator, which returns new ids forever
+    or until it runs out.  This makes it pretty useful for defining
+    menus::
+
+        class Form(wx.Dialog):
+            _form_id_pool = IdList()
+            def __init__(self):
+                ...
+                menu = wx.Menu()
+                for item, wx_id in zip(menu_items, self._form_id_pool):
+                    name, description, callback = item
+                    menu.Append(wx_id, name, description)
+                    wx.EVT_MENU(self, wx_id, callback)
+                ...
+
+    It is a little unusual to use an iterator outside of a loop, but it is
+    supported. For example, when defining a form, your class definition
+    might look something like::
+
+        class Form(wx.Dialog):
+            _form_id_pool = IdList()
+            def __init__(self, pairs, ...):
+                ids = iter(_form_id_pool)
+                ...
+                wx.StaticText(self, ids.next(), "Some key-value pairs")
+                for name, value in pairs:
+                    label = wx.StaticText(self, ids.next(), name)
+                    input = wx.TextCtrl(self, ids.next(), value=str(value))
+                    ...
+                ...
+
+    If the dialog is really dynamic, and not defined all in one place, then
+    save the id list iterator as *self._ids = iter(_form_id_pool)* in the
+    constructor.
+
+    The wx documentation is not clear on whether ids need to be unique.
+    Clearly different dialogs can use the same ids, as this is done for the
+    standard button ids such as wx.ID_HELP.  Presumably each widget on the
+    form needs its own id, but whether these ids can match the ids of menu
+    items is not indicated, or whether different submenus need their own
+    ids.  Using different id lists for menu items and widgets is safest,
+    but probably not necessary.  And what about notebook tabs.  Do the
+    ids need to be unique across all tabs?
+    """
+    def __init__(self):
+        self._ids = []
+    def __iter__(self):
+        return _IdListIterator(self)
+    def __getitem__(self, index):
+        while index >= len(self._ids):
+            self._ids.append(wx.NewId())
+        return self._ids[index]
+
+class _IdListIterator:
+    def __init__(self, id_list):
+        self.id_list = id_list
+        self.index = -1
+    def next(self):
+        self.index += 1
+        return self.id_list[self.index]
+
Index: src/sas/models/PeakGaussModel.py
===================================================================
--- src/sas/models/PeakGaussModel.py	(revision ac7be54ccf932e813cbe6e41e05b682a1630a03e)
+++ src/sas/models/PeakGaussModel.py	(revision d430ee8a3536142d375f39d42bb58a227871cb95)
@@ -3,4 +3,5 @@
 PeakGaussModel function as a BaseComponent model
 """
+from __future__ import division
 
 from sas.models.BaseComponent import BaseComponent
